; load A/X macro
.macro ldax arg
.if (.match (.left (1, arg), #))      ; immediate mode
    lda #<(.right (.tcount (arg)-1, arg))
    ldx #>(.right (.tcount (arg)-1, arg))
.else                                 ; assume absolute or zero page
    lda arg
    ldx 1+(arg)
.endif
.endmacro

; store A/X macro
.macro stax arg
  sta arg
  stx 1+(arg)
.endmacro

; load A/Y macro
.macro lday arg
.if (.match (.left (1, arg), #))      ; immediate mode
    lda #<(.right (.tcount (arg)-1, arg))
    ldy #>(.right (.tcount (arg)-1, arg))
.else                                 ; assume absolute or zero page
    lda arg
    ldy 1+(arg)
.endif
.endmacro

.macro phax
  pha
  txa
  pha
.endmacro

.macro plax
  pla
  tax
  pla
.endmacro



; -- LICENSE FOR common.inc --
; The contents of this file are subject to the Mozilla Public License
; Version 1.1 (the "License"); you may not use this file except in
; compliance with the License. You may obtain a copy of the License at
; http://www.mozilla.org/MPL/
;
; Software distributed under the License is distributed on an "AS IS"
; basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
; License for the specific language governing rights and limitations
; under the License.
;
; The Original Code is ip65.
;
; The Initial Developer of the Original Code is Per Olofsson,
; MagerValp@gmail.com.
; Portions created by the Initial Developer are Copyright (C) 2009
; Per Olofsson. All Rights Reserved.
; -- LICENSE END --
